// D import file generated from 'gl3n/ext/matrixstack.d'
module gl3n.ext.matrixstack;
private import gl3n.util : is_matrix;

template MatrixStack(T) if (is_matrix!T)
{
	struct MatrixStack
	{
		alias T Matrix;
		Matrix top = Matrix.identity;
		private Matrix[] stack;

		private size_t _top_pos = 0;

		alias top this;
size_t realloc_interval = 8;
		pure nothrow this(size_t depth = 16)
		{
			stack.length = depth;
		}

		pure nothrow void set(Matrix matrix)
		{
			top = matrix;
		}

		pure nothrow void push()
		{
			if (stack.length <= _top_pos)
			{
				stack.length += realloc_interval;
			}
			stack[_top_pos++] = top;
		}

		pure nothrow void push(Matrix matrix)
		{
			push();
			top = matrix;
		}

		ref pure nothrow Matrix pop()
		in
		{
			assert(_top_pos >= 1, "popped too often from matrix stack");
		}
		body
		{
			top = stack[--_top_pos];
			return top;
		}


	}
}
