// D import file generated from 'gl3n/frustum.d'
module gl3n.frustum;
private 
{
	import gl3n.linalg : vec3, mat4, dot;
	import gl3n.math : abs, cradians;
	import gl3n.aabb : AABB;
	import gl3n.plane : Plane;
}
enum 
{
	OUTSIDE = 0,
	INSIDE,
	INTERSECT,
}
struct Frustum
{
	enum 
	{
		LEFT,
		RIGHT,
		BOTTOM,
		TOP,
		NEAR,
		FAR,
	}
	Plane[6] planes;
	nothrow pure @safe 
	{
		ref @property Plane left();

		ref @property Plane right();

		ref @property Plane bottom();

		ref @property Plane top();

		ref @property Plane near();

		ref @property Plane far();

		this(mat4 mvp);
		this(Plane[6] planes);
		private void normalize();

		int intersects(AABB aabb);
		template opBinaryRight(string s : "in")
		{
			bool opBinaryRight(AABB aabb)
			{
				return intersects(aabb) > 0;
			}

		}
	}
}
